#include "TXXXMakeUnp2.h"
#include "Riostream.h"
#include "TH1.h"

#include "TXXXEventUnp2.h"

//***********************************************************
TXXXMakeUnp2::TXXXMakeUnp2() : TGo4EventProcessor("Proc")
{
  cout << "**** TXXXMakeUnp2: Create instance " << endl;
}
//***********************************************************
TXXXMakeUnp2::~TXXXMakeUnp2()
{
  cout << "**** TXXXMakeUnp2: Delete instance " << endl;
}
//***********************************************************
// this one is used in standard factory
TXXXMakeUnp2::TXXXMakeUnp2(const char* name) : TGo4EventProcessor(name)
{
  cout << "**** TXXXMakeUnp2: Create instance " << name << endl;

// Create of parameters and histograms (check if restored from auto save file):
  fHis1  = (TH1I *) MakeTH1('I',"Unp2/Unp2His1","Channel 1",1000,1,5000,"Channels");
}
//-----------------------------------------------------------
// event function
Bool_t TXXXMakeUnp2::BuildEvent(TGo4EventElement * output)
{
  Int_t lwords,i;
  Int_t *pdata;
  TGo4MbsSubEvent * rawsub;

  TGo4MbsEvent  * raw    = dynamic_cast<TGo4MbsEvent*>  (GetInputEvent("GetRaw"));
  TXXXEventUnp2 * target = dynamic_cast<TXXXEventUnp2*> (output);
  memset(target->fUnp22, 0, sizeof(target->fUnp22));
  // Copy data from input event into local arrays
  raw->ResetIterator();  // prepare loop over sub-events
  while((rawsub = raw->NextSubEvent()) != 0) // loop over subevents
    {
      pdata  = rawsub->GetDataField(); // pointer to first data longword
      lwords = rawsub->GetIntLen();    // number of longwords
      if(lwords > 8) lwords=8;         // take only first 8 lwords
      if(rawsub->GetSubcrate() == 2)
	for(i = 0; i < lwords; i++) target->fUnp22[i] = (Float_t)*pdata++;
    } // while subevents

  target->SetValid(kTRUE);
  FillHistograms(target); // fill histograms from output event

  return kTRUE;
}

//-----------------------------------------------------------
// histogramming function
Bool_t TXXXMakeUnp2::FillHistograms(TXXXEventUnp2 * event)
{
  fHis1->Fill(event->fUnp22[0]);                        
  return kTRUE;
}
//----------------------------END OF GO4 SOURCE FILE ---------------------
